/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief EEPROM̂߂ٰ
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

/*_____ ݸٰ ____________________________________________________________*/

#define _EEP_LIB_C_
#include "config.h"
#include "eep_drv.h"
#include "eep_lib.h"

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

#ifndef EEPROM_SIZE
  #error You must define EEPROM_SIZE in bytes in config.h
#else

bit eeprom_erase (void)
{
#if EEPROM_SIZE > 0
	register Uint16 addr;

	Enable_eeprom();
	addr=0;
	do {
		while (eeprom_busy());
		eeprom_wr(addr,EEPROM_BLANK_VALUE);
	} while (addr++!=(EEPROM_SIZE-1));
	Disable_eeprom();
#endif
	return TRUE;
}

bit eeprom_wr_byte (Uint16 addr, Uchar value)
{
	Enable_eeprom();
	while (eeprom_busy());
	eeprom_wr(addr,value);
	Disable_eeprom();
	return TRUE;
}

Byte eeprom_rd_byte (Uint16 addr)
{
	register Byte b;
	while (eeprom_busy());
	Enable_eeprom();
	b=eeprom_rd(addr);
	Disable_eeprom();
	return b;
}

bit eeprom_rd_block (Uint16 src, Byte _MemType_* dest, Byte n)
{
	while (eeprom_busy());
	Enable_eeprom();
	for (;n--;++src) *dest++=eeprom_rd(src);
	Disable_eeprom();
	return TRUE;
}

bit eeprom_wr_block (Byte _MemType_* src, Uint16 dest, U16 n)
{
#if EEPROM_SIZE > 0
	Enable_eeprom();
	for (;n--;)
	{
		while (eeprom_busy());
		eeprom_wr(dest,*src++);
		if (dest++==(EEPROM_SIZE-1)) break;		// ߰ނEEPROM򋫊EŐ񂳂ĂȂB
	}
	Disable_eeprom();
#endif
	return TRUE;
}

#endif
